您的位置:首页 > 其它

[LeetCode]-292. Nim Game(Easy)(C + 尼姆游戏)

2016-05-09 11:06 525 查看


292. Nim Game

My Submissions

Question
Editorial Solution

Total Accepted: 67907 Total
Submissions: 128306 Difficulty: Easy

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You
will take the first turn to remove the stones.
Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.
For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.
Hint:

If there are 5 stones in the heap, could you figure out a way to remove the stones such that you will always be the winner?

Credits:

Special thanks to @jianchao.li.fighter for adding this problem and creating all test cases.

Subscribe to see which companies asked this question

Show Tags

Show Similar Problems

Have you met this question in a real interview?

Yes

No

Discuss Notes

这题往小说可以追溯到小学奥数或者脑筋急转弯的书中,往大说可以深究到博弈论。然而编程在这里并没有卵用,

因为目的是给对方最后留下的石头要是4,则对方就必输!因为每个人都取不到4个,假设自己后走,

要保证每轮自己和对方取得数量的和是4,这样就能确保每轮完后都有4的倍数个石头被取走。

这样,如果我们先走的话,先把n除4的余数个石头拿走,这样不管怎样,到最后都会留4个下来,

对方取1个你就取3个,对方取2个你就取2个,对方取3个你就取一个。就必赢了。反之对方也会以同样的思路来思考,

即如果你第一次得到的是4的倍数,则你就必输了!

bool canWinNim(int n) {
//如果一开始就是4的倍数,你就输了,因为对方可以用同样的策略
return (n%4!=0);
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: